/*
 * SuperOffersSupplierView.java
 *
 * Created on 17 de agosto de 2004, 13:30
 */

package com.fenalco.servlets.supplier;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.fenalco.entities.Company;
import com.fenalco.entities.SuperOfferList;
import com.fenalco.entities.User;
import com.fenalco.utilities.MessageBuilder;
import com.fenalco.utilities.lists.SuperOfferListViewSupplier;

/**
 * Este servlet construye un listado de las superofertas creadas para el
 * proveedor, tanto las publicadas como las inactivas.
 * 
 * @author andres
 */
public class SuperOffersSupplierView extends HttpServlet
{

	/**
	 * Inicializa el servlet.
	 * 
	 * @param config
	 *            Parámetro de configuración
	 * @throws ServletException
	 *             Excepción de fallo en la operación de inicialización
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destruye el servlet.
	 */
	public void destroy( )
	{

	}

	/**
	 * Procesa las peticiones para los métodos HTTP <code>GET</code> y
	 * <code>POST</code>.
	 * 
	 * Este método construye un objeto <CODE>SupperOfferList</CODE> utilizando
	 * como parámetros el identificador del proveedor (<CODE>supplierId
	 * </CODE>)y como tipo de empresa el identificador del tipo de empresa
	 * proveedor.
	 * 
	 * Una vez recuperada esta información se procede a remitirla a <CODE>
	 * listasuperofertas.jsp</CODE> para que pueda ser vista por el proveedor.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones
	 * @throws IOException
	 *             Excepción de fallo en la operación de escritura mediante el
	 *             flujo <CODE>PrintWriter</CODE> en response.
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		HttpSession session = request.getSession(false);
		RequestDispatcher dispatcher;
		String url;
		String message = "";

	    try
	    {
	        if( session == null || ( User )session.getAttribute( "user" ) == null || ( ( User )session.getAttribute( "user" ) ).getRoleId() != 2 )
			{
				url = "/logout";
				//message = "Sesión no iniciada";
				message = MessageBuilder.buildMessage(15);
			}
			else
			{
				User supplier = (User) session.getAttribute("user");
				Company company = new Company(supplier.getCompanyId());
				SuperOfferList superOfferList = new SuperOfferList(supplier
						.getCompanyId(), company.getType());
				superOfferList.filter(1);
				SuperOfferListViewSupplier view = new SuperOfferListViewSupplier(
						superOfferList);
	
				if( view == null )
				{
					//Fallo en la carga del listado de superofertas
					//message = "Fallo en la carga del listado de superofertas";
					message = MessageBuilder.buildMessage(9);
					url = "/proveedor/listasuperofertas.jsp";
				}
				else
				{
					//message = "El listado de superofertas se creó correctamente";
					//message = MessageBuilder.buildMessage(3);
					message = "";
					url = "/proveedor/listasuperofertas.jsp";
	
					request.setAttribute("view", view);
				}
	
			}
	
			if( request.getAttribute("message") != null )
			{
				message = (String) request.getAttribute("message");
			}
	    }
	    catch( Exception e )
	    {
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }

		request.setAttribute("message", message);
		dispatcher = getServletContext().getRequestDispatcher(url);
		dispatcher.forward(request, response);
	}

	/**
	 * Maneja el método HTTP <code>GET</code>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones
	 * @throws IOException
	 *             Excepción de fallo en la operación de escritura mediante el
	 *             flujo <CODE>PrintWriter</CODE> en response.
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Maneja el método HTTP <code>POST</code>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones
	 * @throws IOException
	 *             Excepción de fallo en la operación de escritura mediante el
	 *             flujo <CODE>PrintWriter</CODE> en response.
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Información general del servlet
	 * 
	 * @return Retorna una descripción general del servlet
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

}